Skip to content
React Native BLE library
Branch: master
Clone or download
Pull request Compare This branch is 3 commits behind Polidea:master.
Fetching latest commit…
Cannot retrieve the latest commit at this time.
Permalink
Type Name Latest commit message Commit time
Failed to load latest commit information.
.github
.vscode
__tests__
android
docs
integration-tests
ios
src
.buckconfig
.eslintrc.json
.flowconfig
.gitattributes
.gitignore
.npmignore
.travis.yml
.watchmanconfig
CHANGELOG.md
INTRO.md
LICENSE
README.md
RELEASE.md
babel.config.js
documentation.yml
index.d.ts
index.js
jsconfig.json
package-lock.json
package.json
react-native-ble-plx-swift.podspec
react-native-ble-plx.podspec

README.md

react-native-ble-plx

About this library

This is React Native Bluetooth Low Energy library using RxBluetoothKit and RxAndroidBle under the hood.

It supports:

What this library does NOT support:

Compatibility

React Native 1.0.3
0.59.3
0.59.1
0.59.0
0.58.3
0.58.0
0.57.8
0.57.5
0.57.2
0.56.1 💥1
0.55.4 💥1

1 fails on Android, although might work after updating gradle

Recent Changes

1.0.3

  • Integrated Travis CI to test library and check its integration with multiple RN versions.
  • Library's build.gradle prefers buildToolsVersion, compileSdkVersion & targetSdkVersion specified in rootProject.
  • Added Typescript definitions.
  • Removed outdated example project.
  • Updated dev dependencies and the README file.

All previous changes

Documentation & Support

Interested in React Native project involving Bluetooth Low Energy? We can help you!

Documentation can be found here.

Contact us at Gitter if you have any questions, feedback or want to help!

Configuration & Installation

iOS (pure react-native, example setup)

  1. npm install --save react-native-ble-plx
  2. react-native link react-native-ble-plx
  3. Add empty Swift file if you don't have at least one:
    • Select File/New/File...
    • Choose Swift file and click Next.
    • Name it however you want, select your targets and create it.
    • Accept to create Objective-C bridging header.
  4. Minimal supported version of iOS is 8.0
  5. If you want to support background mode:
    • In your application target go to Capabilities tab and enable Uses Bluetooth LE Accessories in Background Modes section.
    • Pass restoreStateIdentifier and restoreStateFunction to BleManager constructor.

iOS (expo/Podfile, example setup)

  1. Make sure your Expo project is ejected (formerly: detached). You can read how to do it here and here.
  2. npm install --save react-native-ble-plx
  3. react-native link react-native-ble-plx
  4. Add empty Swift file if you don't have at least one:
    • Select File/New/File...
    • Choose Swift file and click Next.
    • Name it however you want, select your application target and create it.
    • Accept to create Objective-C bridging header.
  5. Update your ios/Podfile to contain:
    pod 'react-native-ble-plx', :path => '../node_modules/react-native-ble-plx'
    pod 'react-native-ble-plx-swift', :path => '../node_modules/react-native-ble-plx'
    
  6. Enter ios folder and run pod update
  7. Minimal supported version of iOS is 8.0
  8. If you want to support background mode:
    • In your application target go to Capabilities tab and enable Uses Bluetooth LE Accessories in Background Modes section.
    • Pass restoreStateIdentifier and restoreStateFunction to BleManager constructor.

Android (example setup)

  1. npm install --save react-native-ble-plx
  2. react-native link react-native-ble-plx
  3. In build.gradle of app module make sure that min SDK version is at least 18:
android {
    ...
    defaultConfig {
        minSdkVersion 18
        ...
  1. In AndroidManifest.xml, add Bluetooth permissions and update <uses-sdk/>:
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
    ...
    <uses-permission android:name="android.permission.BLUETOOTH"/>
    <uses-permission android:name="android.permission.BLUETOOTH_ADMIN"/>
    <uses-permission-sdk-23 android:name="android.permission.ACCESS_COARSE_LOCATION"/>

    <!-- Add this line if your application always requires BLE. More info can be found on:
         https://developer.android.com/guide/topics/connectivity/bluetooth-le.html#permissions
      -->
    <uses-feature android:name="android.hardware.bluetooth_le" android:required="true"/>

    <uses-sdk
        android:minSdkVersion="18"
        ...

Troubleshooting

Problems with Proguard

Add this to your app/proguard-rules.pro

-dontwarn com.polidea.reactnativeble.**
You can’t perform that action at this time.